diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/rawtextdump.cpp libkdcraw/libkdcraw/libraw/samples/rawtextdump.cpp
--- libkdcraw-wrk/libkdcraw/libraw/samples/rawtextdump.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/samples/rawtextdump.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -0,0 +1,144 @@
+/* -*- C++ -*-
+ * File: raw2text.cpp
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
+ * Created: Sun Sept 01, 2020
+ *
+ * LibRaw sample
+ * Dumps (small) selection of RAW data to text file
+ *
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+
+ */
+#include <stdio.h>
+#include <string.h>
+#include <math.h>
+#ifndef WIN32
+#include <netinet/in.h>
+#else
+#include <winsock2.h>
+#endif
+
+#include "libraw/libraw.h"
+
+void usage(const char *av)
+{
+	printf(
+		"Dump (small) selecton of RAW file as tab-separated text file\n"
+		"Usage: %s inputfile COL ROW [CHANNEL] [width] [height]\n"
+		"  COL - start column\n"
+		"  ROW - start row\n"
+		"  CHANNEL - raw channel to dump, default is 0 (red for rggb)\n"
+		"  width - area width to dump, default is 16\n"
+		"  height - area height to dump, default is 4\n"
+		, av);
+}
+
+unsigned subtract_bl(unsigned int val, int bl)
+{
+	return val > (unsigned)bl ? val - (unsigned)bl : 0;
+}
+
+class LibRaw_bl : public LibRaw
+{
+	public:
+		void adjust_blacklevel() { LibRaw::adjust_bl(); }
+};
+
+int main(int ac, char *av[])
+{
+	if (ac < 4)
+	{
+		usage(av[0]);
+		exit(1);
+	}
+	int colstart = atoi(av[2]);
+	int rowstart = atoi(av[3]);
+	int channel = 0;
+	if (ac > 4) channel = atoi(av[4]);
+	int width = 16;
+	if (ac > 5) width = atoi(av[5]);
+	int height = 4;
+	if (ac > 6) height = atoi(av[6]);
+	if (width <1 || height<1)
+	{
+		usage(av[0]);
+		exit(1);
+	}
+
+	LibRaw_bl lr;
+
+	if (lr.open_file(av[1]) != LIBRAW_SUCCESS)
+	{
+		fprintf(stderr, "Unable to open file %s\n", av[1]);
+		exit(1);
+	}
+	if ((lr.imgdata.idata.colors == 1 && channel>0) || (channel >3))
+	{
+		fprintf(stderr, "Incorrect CHANNEL specified: %d\n", channel);
+		exit(1);
+	}
+	if (lr.unpack() != LIBRAW_SUCCESS)
+	{
+		fprintf(stderr, "Unable to unpack raw data from %s\n", av[1]);
+		exit(1);
+	}
+	lr.adjust_blacklevel();
+	printf("%s\t%d-%d-%dx%d\tchannel: %d\n", av[1], colstart, rowstart, width, height, channel);
+
+	printf("%6s", "R\\C");
+	for (int col = colstart; col < colstart + width && col < lr.imgdata.sizes.raw_width; col++)
+		printf("%6u", col);
+	printf("\n");
+
+	if (lr.imgdata.rawdata.raw_image)
+	{
+		for (int row = rowstart; row < rowstart + height && row < lr.imgdata.sizes.raw_height; row++)
+		{
+			unsigned rcolors[48];
+			if (lr.imgdata.idata.colors > 1)
+				for (int c = 0; c < 48; c++)
+					rcolors[c] = lr.COLOR(row, c);
+			else
+				memset(rcolors, 0, sizeof(rcolors));
+			unsigned short *rowdata = &lr.imgdata.rawdata.raw_image[row * lr.imgdata.sizes.raw_pitch / 2];
+			printf("%6u", row);
+			for (int col = colstart; col < colstart + width && col < lr.imgdata.sizes.raw_width; col++)
+				if (rcolors[col % 48] == (unsigned)channel) printf("%6u", subtract_bl(rowdata[col],lr.imgdata.color.cblack[channel]));
+				else printf("     -");
+			printf("\n");
+		}
+	}
+	else if (lr.imgdata.rawdata.color4_image && channel < 4)
+	{
+		for (int row = rowstart; row < rowstart + height && row < lr.imgdata.sizes.raw_height; row++)
+		{
+			unsigned short(*rowdata)[4] = &lr.imgdata.rawdata.color4_image[row * lr.imgdata.sizes.raw_pitch / 8];
+			printf("%6u", row);
+			for (int col = colstart; col < colstart + width && col < lr.imgdata.sizes.raw_width; col++)
+				printf("%6u", subtract_bl(rowdata[col][channel],lr.imgdata.color.cblack[channel]));
+			printf("\n");
+		}
+	}
+	else if (lr.imgdata.rawdata.color3_image && channel < 3)
+	{
+		for (int row = rowstart; row < rowstart + height && row < lr.imgdata.sizes.raw_height; row++)
+		{
+			unsigned short(*rowdata)[3] = &lr.imgdata.rawdata.color3_image[row * lr.imgdata.sizes.raw_pitch / 6];
+			printf("%6u", row);
+			for (int col = colstart; col < colstart + width && col < lr.imgdata.sizes.raw_width; col++)
+				printf("%6u", subtract_bl(rowdata[col][channel],lr.imgdata.color.cblack[channel]));
+			printf("\n");
+		}
+	}
+	else
+		printf("Unsupported file data (e.g. floating point format), or incorrect channel specified\n");
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/simple_dcraw.cpp libkdcraw/libkdcraw/libraw/samples/simple_dcraw.cpp
--- libkdcraw-wrk/libkdcraw/libraw/samples/simple_dcraw.cpp	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/samples/simple_dcraw.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -1,213 +1,189 @@
-/*
+/* -*- C++ -*-
  * File: simple_dcraw.cpp
- * Copyright 2008-2009 Alex Tutubalin <lexa@lexa.ru>
- * Created: Sat Mar  8 , 2008
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
+ * Created: Sat Mar  8, 2008
  *
- * LibRaw simple C++ API  (emulates call to "dcraw  [-D]  [-T] [-v] [-e] [-4]")
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+ * LibRaw simple C++ API:  emulates call to "dcraw  [-D]  [-T] [-v] [-e] [-4]"
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+
  */
 #include <stdio.h>
 #include <string.h>
 #include <math.h>
 
-#ifndef WIN32
+#include "libraw/libraw.h"
+
+#ifndef LIBRAW_WIN32_CALLS
 #include <unistd.h>
 #include <fcntl.h>
 #include <sys/stat.h>
 #include <sys/mman.h>
 #endif
 
-#include "libraw/libraw.h"
-
-#ifdef WIN32
+#ifdef LIBRAW_WIN32_CALLS
 #define snprintf _snprintf
 #endif
 
-int my_progress_callback(void *unused_data,enum LibRaw_progress state,int iter, int expected)
+int my_progress_callback(void *unused_data, enum LibRaw_progress state,
+                         int iter, int expected)
 {
-    if(iter==0)
-        printf("CB: state=%x, expected %d iterations\n",state,expected);
-    return 0;
+  if (iter == 0)
+    printf("CB: state=%x, expected %d iterations\n", state, expected);
+  return 0;
 }
 
+char *customCameras[] = {
+    (char *)"43704960,4080,5356, 0, 0, 0, 0,0,148,0,0, Dalsa, FTF4052C Full,0",
+    (char *)"42837504,4008,5344, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF4052C 3:4",
+    (char *)"32128128,4008,4008, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF4052C 1:1",
+    (char *)"24096096,4008,3006, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF4052C 4:3",
+    (char *)"18068064,4008,2254, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF4052C 16:9",
+    (char *)"67686894,5049,6703, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF5066C Full",
+    (char *)"66573312,4992,6668, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF5066C 3:4",
+    (char *)"49840128,4992,4992, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF5066C 1:1",
+    (char *)"37400064,4992,3746, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF5066C 4:3",
+    (char *)"28035072,4992,2808, 0, 0, 0, 0,0,148,0,0,Dalsa, FTF5066C 16:9",
+    NULL};
 
 int main(int ac, char *av[])
 {
-    int  i, ret, verbose=0, output_thumbs=0,use_mmap=0,msize;
-    void *file_buffer;
+  int i, ret, verbose = 0, output_thumbs = 0;
+
+  // don't use fixed size buffers in real apps!
+  char outfn[1024], thumbfn[1024];
+
+  LibRaw* RawProcessor = new LibRaw;
+  RawProcessor->imgdata.params.custom_camera_strings = customCameras;
+  if (ac < 2)
+  {
+    printf("simple_dcraw - LibRaw %s sample. Emulates dcraw [-D] [-T] [-v] "
+           "[-e] [-E]\n"
+           " %d cameras supported\n"
+           "Usage: %s [-D] [-T] [-v] [-e] raw-files....\n"
+           "\t-4 - 16-bit mode\n"
+           "\t-L - list supported cameras and exit\n"
+           "\t-v - verbose output\n"
+           "\t-T - output TIFF files instead of .pgm/ppm\n"
+           "\t-e - extract thumbnails (same as dcraw -e in separate run)\n",
+           LibRaw::version(), LibRaw::cameraCount(), av[0]);
+    delete RawProcessor;
+    return 0;
+  }
 
-    // don't use fixed size buffers in real apps!
-    char outfn[1024],thumbfn[1024]; 
+  putenv((char *)"TZ=UTC"); // dcraw compatibility, affects TIFF datestamp field
 
-    LibRaw RawProcessor;
-    if(ac<2) 
+#define P1 RawProcessor->imgdata.idata
+#define S RawProcessor->imgdata.sizes
+#define C RawProcessor->imgdata.color
+#define T RawProcessor->imgdata.thumbnail
+#define P2 RawProcessor->imgdata.other
+#define OUT RawProcessor->imgdata.params
+
+  for (i = 1; i < ac; i++)
+  {
+    if (av[i][0] == '-')
+    {
+      if (av[i][1] == 'T' && av[i][2] == 0)
+        OUT.output_tiff = 1;
+      if (av[i][1] == 'v' && av[i][2] == 0)
+        verbose++;
+      if (av[i][1] == 'e' && av[i][2] == 0)
+        output_thumbs++;
+      if (av[i][1] == '4' && av[i][2] == 0)
+        OUT.output_bps = 16;
+      if (av[i][1] == 'C' && av[i][2] == 0)
+        RawProcessor->set_progress_handler(my_progress_callback, NULL);
+      if (av[i][1] == 'L' && av[i][2] == 0)
+      {
+        const char **clist = LibRaw::cameraList();
+        const char **cc = clist;
+        while (*cc)
         {
-            printf(
-                "simple_dcraw - LibRaw %s sample. Emulates dcraw [-D] [-T] [-v] [-e] [-B]\n"
-                " %d cameras supported\n"
-                "Usage: %s [-D] [-T] [-v] [-e] raw-files....\n"
-                "\t-D - document mode emulation\n"
-                "\t-4 - 16-bit mode\n"
-                "\t-v - verbose output\n"
-                "\t-T - output TIFF files instead of .pgm/ppm\n"
-#ifndef WIN32
-                "\t-B - use mmap()-ed I/O (Unix only)\n"
-#endif
-                "\t-e - extract thumbnails (same as dcraw -e in separate run)\n",LibRaw::version(),
-                LibRaw::cameraCount(),
-                av[0]);
-            return 0;
+          printf("%s\n", *cc);
+          cc++;
+        }
+        delete RawProcessor;
+        exit(0);
+      }
+      continue;
+    }
+
+    if (verbose)
+      printf("Processing file %s\n", av[i]);
+
+    if ((ret = RawProcessor->open_file(av[i])) != LIBRAW_SUCCESS)
+    {
+      fprintf(stderr, "Cannot open_file %s: %s\n", av[i], libraw_strerror(ret));
+      continue; // no recycle b/c open file will recycle itself
+    }
+
+    if (!output_thumbs) // No unpack for thumb extraction
+      if ((ret = RawProcessor->unpack()) != LIBRAW_SUCCESS)
+      {
+        fprintf(stderr, "Cannot unpack %s: %s\n", av[i], libraw_strerror(ret));
+        continue;
+      }
+
+    // thumbnail unpacking and output in the middle of main
+    // image processing - for test purposes!
+    if (output_thumbs)
+    {
+      if ((ret = RawProcessor->unpack_thumb()) != LIBRAW_SUCCESS)
+      {
+        fprintf(stderr, "Cannot unpack_thumb %s: %s\n", av[i],
+                libraw_strerror(ret));
+        if (LIBRAW_FATAL_ERROR(ret))
+          continue; // skip to next file
+      }
+      else
+      {
+        snprintf(thumbfn, sizeof(thumbfn), "%s.%s", av[i],
+                 T.tformat == LIBRAW_THUMBNAIL_JPEG ? "thumb.jpg"
+                                                    : "thumb.ppm");
+
+        if (verbose)
+          printf("Writing thumbnail file %s\n", thumbfn);
+        if (LIBRAW_SUCCESS != (ret = RawProcessor->dcraw_thumb_writer(thumbfn)))
+        {
+          fprintf(stderr, "Cannot write %s: %s\n", thumbfn,
+                  libraw_strerror(ret));
+          if (LIBRAW_FATAL_ERROR(ret))
+            continue;
         }
-    
-    putenv ((char*)"TZ=UTC"); // dcraw compatibility, affects TIFF datestamp field
+      }
+      continue;
+    }
+
+    ret = RawProcessor->dcraw_process();
+
+    if (LIBRAW_SUCCESS != ret)
+    {
+      fprintf(stderr, "Cannot do postpocessing on %s: %s\n", av[i],
+              libraw_strerror(ret));
+      if (LIBRAW_FATAL_ERROR(ret))
+        continue;
+    }
+    snprintf(outfn, sizeof(outfn), "%s.%s", av[i],
+             OUT.output_tiff ? "tiff" : (P1.colors > 1 ? "ppm" : "pgm"));
+
+    if (verbose)
+      printf("Writing file %s\n", outfn);
 
-#define P1 RawProcessor.imgdata.idata
-#define S RawProcessor.imgdata.sizes
-#define C RawProcessor.imgdata.color
-#define T RawProcessor.imgdata.thumbnail
-#define P2 RawProcessor.imgdata.other
-#define OUT RawProcessor.imgdata.params
+    if (LIBRAW_SUCCESS != (ret = RawProcessor->dcraw_ppm_tiff_writer(outfn)))
+      fprintf(stderr, "Cannot write %s: %s\n", outfn, libraw_strerror(ret));
 
+    RawProcessor->recycle(); // just for show this call
+  }
 
-    for (i=1;i<ac;i++)
-        {
-            if(av[i][0]=='-')
-                {
-                    if(av[i][1]=='T' && av[i][2]==0)
-                        OUT.output_tiff=1;
-                    if(av[i][1]=='v' && av[i][2]==0)
-                        verbose++;
-                    if(av[i][1]=='e' && av[i][2]==0)
-                        output_thumbs++;
-                    if(av[i][1]=='D' && av[i][2]==0)
-                        OUT.document_mode=2;
-                    if(av[i][1]=='B' && av[i][2]==0)
-                        use_mmap=1;
-                    if(av[i][1]=='4' && av[i][2]==0)
-                        OUT.output_bps=16;
-                    if(av[i][1]=='C' && av[i][2]==0)
-                        RawProcessor.set_progress_handler(my_progress_callback,NULL);
-                    continue;
-                }
-
-            if(verbose) printf("Processing file %s\n",av[i]);
-
-#ifndef WIN32
-            if(use_mmap)
-                {
-                    int file = open(av[i],O_RDONLY);
-                    struct stat st;
-                    if(file<0)
-                        {
-                            fprintf(stderr,"Cannot open %s: %s\n",av[i],strerror(errno));
-                            continue;
-                        }
-                    if(fstat(file,&st))
-                        {
-                            fprintf(stderr,"Cannot stat %s: %s\n",av[i],strerror(errno));
-                            close(file);
-                            continue;
-                        }
-                    int pgsz = getpagesize();
-                    msize = ((st.st_size+pgsz-1)/pgsz)*pgsz;
-                    file_buffer = mmap(NULL,msize,PROT_READ,MAP_PRIVATE,file,0);
-                    if(!file_buffer)
-                        {
-                            fprintf(stderr,"Cannot mmap %s: %s\n",av[i],strerror(errno));
-                            close(file);
-                            continue;
-                        }
-                    close(file);
-                    if( (ret = RawProcessor.open_buffer(file_buffer,st.st_size) != LIBRAW_SUCCESS))
-                        {
-                            fprintf(stderr,"Cannot open_buffer %s: %s\n",av[i],libraw_strerror(ret));
-                            continue; // no recycle b/c open file will recycle itself
-                        }
-                }
-            else
-#endif
-                {
-                    if( (ret = RawProcessor.open_file(av[i])) != LIBRAW_SUCCESS)
-                        {
-                            fprintf(stderr,"Cannot open_file %s: %s\n",av[i],libraw_strerror(ret));
-                            continue; // no recycle b/c open file will recycle itself
-                        }
-                }
-
-            if( (ret = RawProcessor.unpack() ) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot unpack %s: %s\n",av[i],libraw_strerror(ret));
-                    continue;
-                }
-
-            // thumbnail unpacking and output in the middle of main
-            // image processing - for test purposes!
-            if(output_thumbs)
-                {
-                    if( (ret = RawProcessor.unpack_thumb() ) != LIBRAW_SUCCESS)
-                        {
-                            fprintf(stderr,"Cannot unpack_thumb %s: %s\n",av[i],libraw_strerror(ret));
-                            if(LIBRAW_FATAL_ERROR(ret))
-                                continue; // skip to next file
-                        }
-                    else
-                        {
-                            snprintf(thumbfn,sizeof(thumbfn),"%s.%s",
-                                     av[i],T.tformat == LIBRAW_THUMBNAIL_JPEG ? "thumb.jpg" : "thumb.ppm");
-
-                            if(verbose) printf("Writing thumbnail file %s\n",thumbfn);
-                            if( LIBRAW_SUCCESS != (ret = RawProcessor.dcraw_thumb_writer(thumbfn)))
-                                {
-                                    fprintf(stderr,"Cannot write %s: %s\n",thumbfn,libraw_strerror(ret));
-                                    if(LIBRAW_FATAL_ERROR(ret))
-                                        continue; 
-                                }
-                        }
-                }
-            
-            if(OUT.document_mode)
-                ret = RawProcessor.dcraw_document_mode_processing();
-            else
-                ret = RawProcessor.dcraw_process();
-                
-            if(LIBRAW_SUCCESS !=ret)
-                {
-                    fprintf(stderr,"Cannot do postpocessing on %s: %s\n",
-                            av[i],libraw_strerror(ret));
-                    if(LIBRAW_FATAL_ERROR(ret))
-                        continue; 
-                }
-            snprintf(outfn,sizeof(outfn),
-                     "%s.%s",
-                     av[i], OUT.output_tiff ? "tiff" : (P1.colors>1?"ppm":"pgm"));
-
-            if(verbose) printf("Writing file %s\n",outfn);
-
-            if( LIBRAW_SUCCESS != (ret = RawProcessor.dcraw_ppm_tiff_writer(outfn)))
-                fprintf(stderr,"Cannot write %s: %s\n",outfn,libraw_strerror(ret));
-
-#ifndef WIN32            
-            if(use_mmap && file_buffer)
-                {
-                    munmap(file_buffer,msize);
-                    file_buffer=0;
-                }
-#endif
-            RawProcessor.recycle(); // just for show this call
-        }
-    return 0;
+  delete RawProcessor;
+  return 0;
 }
